# include	<stdio.h>
# include	"ctype8.h"
# include	"grk.h"
# ifdef		BSD
#     include	<sys/ioctl.h>
# else
#     include	<termio.h>
# endif
# include	<signal.h>

# define	GEN_LEN		3	/* strlen(genable)  */
# define	GDIS_LEN	3	/* strlen(gdisable) */

extern int          child;

char               *genable = "\033(1";
char               *gdisabl = "\033(B";
char               *vt220_greek = "/usr/ntua/lib/fonts/Greek.8x10";
FKMAP               vt100_map;
FKMAP               vt220_map;
FKMAP               sun_map;
FKMAP               xterm_map;

extern int          debug;
int		    has_key_greek = FALSE;

FUNC_KEY            vt220_keys[] = {
	KEY_F6, "\033[17~", "\033[17~",
	KEY_F7, "\033[18~", "\033[18~",
	KEY_F8, "\033[19~", "\033[19~",
	KEY_F9, "\033[20~", "\033[20~",
	KEY_F10, "\033[21~", "\033[21~",
	KEY_ESC, "\033[23~", "\033",
	KEY_BS, "\033[24~", "\b",
	KEY_LF, "\033[25~", "\n",
	KEY_F14, "\033[26~", "\033[26~",
	KEY_HELP, "\033[28~", "\033[28~",
	KEY_DO, "\033[29~", "\033[29~",
	KEY_FIND, "\033[1~", "\033[1~",
	KEY_INS, "\033[2~", "\033[2~",
	KEY_REM, "\033[3~", "\033[3~",
	KEY_SELECT, "\033[4~", "\033[4~",
	KEY_PREVSCR, "\033[5~", "\02",
	KEY_NEXTSCR, "\033[6~", "\06",
	KEY_UP, "\033[A", "\033[A",
	KEY_DOWN, "\033[B", "\033[B",
	KEY_RIGHT, "\033[C", "\033[C",
	KEY_LEFT, "\033[D", "\033[D",
	KEY_PF1, "\033OP", "\033OP",
	KEY_PF2, "\033OQ", "\033OQ",
	KEY_PF3, "\033OR", "\033OR",
	KEY_PF4, "\033OS", "\033OS",
	-1, 0, 0
};

FUNC_KEY            xterm_keys[] = {
	KEY_UP, "\033OA", "\033OA",
	KEY_DOWN, "\033OB", "\033OB",
	KEY_RIGHT, "\033OC", "\033OC",
	KEY_LEFT, "\033OD", "\033OD",
	KEY_GREEK, "\033[18~", "\033[18~",
	KEY_HELP, "\033[13~", "\033[13~",
	KEY_PF3, "\033[19~", "\033[19~",
	KEY_PF4, "\033[20~", "\033[20~",
	-1, 0, 0
};


FUNC_KEY            sun_keys[] = {
	KEY_UP, "\033[A", "\033[A",
	KEY_DOWN, "\033[B", "\033[B",
	KEY_RIGHT, "\033[C", "\033[C",
	KEY_LEFT, "\033[D", "\033[D",
	KEY_GREEK, "\033[235z", "\033[235z",
	KEY_HELP, "\033[207z", "\033[207z",
	KEY_PF3, "\033[208z", "\033[208z",
	KEY_PF4, "\033[209z", "\033[209z",
	-1, 0, 0
};

FUNC_KEY            vt100_keys[] = {
	KEY_UP, "\033[A", "\033[A",
	KEY_DOWN, "\033[B", "\033[B",
	KEY_RIGHT, "\033[C", "\033[C",
	KEY_LEFT, "\033[D", "\033[D",
	KEY_GREEK, "\033OP", "\033OP",
	KEY_HELP, "\033OQ", "\033OQ",
	KEY_PF3, "\033OR", "\033OR",
	KEY_PF4, "\033OS", "\033OS",
	-1, 0, 0
};

TERMTAB             term_funcs[] = {
	"vt100", vt100_init_input, null_func,
	vt100_input, vt100_output,

	"vt220", vt220_init_input, vt220_init_output,
	vt220_input, vt220_output,

	"sun-34", sun_init_input, null_func,
	sun_input, vt220_output,
	
	"sun", sun_init_input, null_func,
	sun_input, vt220_output,
	
	"xterm", xterm_init_input, null_func,
	xterm_input, vt220_output,

	"xterms", xterm_init_input, null_func,
	xterm_input, xterm_output,

	(char *) 0, null_func, null_func,
	null_func, null_func
};

TERMTAB            *trm = &(term_funcs[0]);

static              tty_map_crlf = 1;	/* should I map CR-> CR+LF ? */
static              tty_echo = 1;	/* should I do local echo ? */

/*
** key_mapped (k, f)
**
**	Returns the sequence to which function key f must be mapped
*/

char               *
key_mapped (k, f)
	int                 k;
	FUNC_KEY           *f;
{
	for (; f -> code != -1; f++)
		if (f -> code == k)
			return (f -> mapped);
	return ((char *) 0);
}

/*
** set_term ()
**
*/

set_term ()
{
	char               *term, *getenv ();

	if (!(term = getenv ("TERM"))) {
		fprintf (stderr, "Cannot find your terminal type\n");
		goto not_found;
	}
	for (trm = term_funcs; trm -> name; trm++)
		if (strcmp (term, trm -> name) == 0)
			goto initialize;
	fprintf (stderr, "Unknown terminal type `%s'.\n", term);
not_found:
	fprintf (stderr, "Assuming that it is vt102 compatible\n");
	trm = &(term_funcs[0]);
initialize:
	(trm -> init_input) ();
	(trm -> init_output) ();
}

dooutput ()
{
	(trm -> make_output) ();
}

doinput ()
{
	(trm -> make_input) ();
}

void
outstr (s)
	char               *s;
{
	(void) write (1, s, strlen (s));
}


/*
** do_help ():
**
**	Print function key Mappings
*/

void
do_help ()
{
	static char        *vt220_mess[] = {
		"F11		<Escape>",
		"F12		<Backspace>",
		"F13		<Line Feed>",
		"HELP		Prints this list",
		"DO,		Toggles between Greek and Latin keyboard",
		"PF3		Suspend grk",
		"PF4		Resume suspended processes",
		0, 0
	};

	static char        *xterm_mess[] = {
		"F3  		Prints this list",
		"F7 		Toggles between Greek and Latin keyboard",
		"F8        	Suspend grk",
		"F9        	Resume suspended processes",
		0, 0
	};

	static char        *sun_mess[] = {
		"HELP		Prints this list",
		"F12		Toggles between Greek and Latin keyboard",
		"Pause (R1)	Suspend grk",
		"PrSc  (R2)	Resume suspended processes",
		0, 0
	};

	char **m;
	register int        i;


	if (strcmp (trm -> name, "vt220") == 0)
		m = vt220_mess;
	else if (strcmp (trm -> name, "xterm") == 0)
		m = xterm_mess;
	else
		m = sun_mess;
	write (1, "\n\r\n\r", 4);
	for (i = 0; m[i]; i++) {
		write (1, "\t", 1);
		write (1, m[i], strlen (m[i]));
		write (1, "\n\r", 2);
	}
	write (1, "\n\r\n\r", 4);
}

void
init_input (map, keys)
	FKMAP              *map;
	FUNC_KEY            keys[];

{
	register FUNC_KEY  *f;

	fkinitmap (map);
	for (f = keys; f -> code != -1; f++)
		(void) fkinstall (map, f -> sends, f -> code);
}

void
vt220_init_input ()
{
	init_input (&vt220_map, vt220_keys);
	has_key_greek = TRUE;
}

void
xterm_init_input ()
{
	extern int          Char_delay;

	init_input (&xterm_map, xterm_keys);
	has_key_greek = TRUE;
}

void
sun_init_input ()
{
	extern int          Char_delay;

	init_input (&sun_map, sun_keys);
	has_key_greek = TRUE;
}

void
vt100_init_input ()
{
	extern int          Char_delay;

	init_input (&vt100_map, vt100_keys);
	Char_delay = 100;
}

void
vt220_init_output ()
{
	FILE               *font_file, *fopen ();
	register int        fd, n;
	char                buf[BUFSIZ];

	outstr ("Downloading terminal. Please wait ...");
	outstr ("\033[62;1\"p\033[?7h");	/* Set terminal in VT220 mode */
	if (!(font_file = fopen (vt220_greek, "r"))) {
		perror (vt220_greek);
		return;
	}
	fd = fileno (font_file);
	while ((n = read (fd, buf, sizeof (buf))) > 0)
		if (write (1, buf, n) != n) {
			perror ("write");
			break;
		}
	(void) fclose (font_file);
	outstr (" done\n");
}

void
null_func ()
{
	return;
}

void
gen_input (map, keys)
	FKMAP              *map;
	FUNC_KEY           *keys;
{
	int                 key, omask;
	u_char              c, t;
	register int        greek = FALSE, ltnext = FALSE;
	register int        acc = FALSE, uml = FALSE;
	char               *seq;

	check_tty (slave);
	while ((key = fkgetch (map)) != EOF) {
		/*
		 * Check for literal nexting
		 */
		if (ltnext) {
			if (!(seq = key_mapped (key, keys))) {
				c = key & 0377;
				(void) write (master, &c, 1);
			} else 
				(void) write (master, seq, strlen (seq));
			ltnext = FALSE;
			continue;
		}
		if (iskey (key)) {

			switch (key) {
			    case KEY_GREEK:
				greek = !greek;
				uml = acc = FALSE;
				continue;
			    case KEY_HELP:
				do_help ();
				continue;
# if defined(SIGTSTP) && !defined(NO_SUSP)
			    case KEY_STOP:
				noraw ();
				omask = sigsetmask (0);
				if (kill (getpid (), SIGTSTP) != 0)
					perror ("kill");

				/*
				 * Hopefully resuming here after a SIGCONT
				 */
				raw ();
				(void) sigsetmask (omask);
				continue;
			    case KEY_CONT:

				/*
				 * Send a SIGCONT to the suspended csh
				 */
				if (kill (child, SIGCONT) != 0)
					perror ("kill");
				if (kill (0, SIGCONT) != 0)
					perror ("kill");
				continue;
# endif
			    default:
				seq = key_mapped (key, keys);
				(void) write (master, seq, strlen (seq));
				continue;
			}
		} else {
			c = key & 0377;
			switch (key) {
			    case ctrl ('A'):
				if (has_key_greek) 
					(void) write (master, (char *) &c, 1);
				else {
					greek = !greek;
					uml = acc = FALSE;
				}
				continue;
			    case ctrl ('V'):
				(void) write (master, (char *) &c, 1);
				ltnext = TRUE;
				continue;
# ifdef		TIOCSTOP
			    case ctrl ('S'):
				if (ioctl (1, TIOCSTOP, (char *) 0) != 0)
					perror ("ioctl");
				break;
			    case ctrl ('Q'):
				if (ioctl (1, TIOCSTART, (char *) 0) != 0)
					perror ("ioctl");
				break;
# endif
			    case '\'':
				if (greek && !acc) {
					acc = TRUE;
					continue;
				}
				break;
			    case '"':
				if (greek && !uml) {
					uml = TRUE;
					continue;
				}
				break;
			}
		}
		if (!greek)
			(void) write (master, (char *) &c, 1);
		else {
			if (acc && uml) {
				if (t = accum (c))
					c = t;
				else {
					c = To_Greek (c);
					(void) write (master, "'\"", 2);
				}
			} else if (acc) {
				if (t = accent (c))
					c = t;
				else {
					c = To_Greek (c);
					(void) write (master, "'", 1);
				}
			} else if (uml) {
				if (t = umlaut (c))
					c = t;
				else {
					c = To_Greek (c);
					(void) write (master, "\"", 1);
				}
			} else
				c = To_Greek (c);
			acc = uml = 0;
			(void) write (master, (char *) &c, 1);
			Debug (debug_print ("in", c));
		}

		/*
		 * Check for change of the slave tty --mt we only do it after a
		 * CR has been received It seems very expensive to do it every
		 * character.
		 */
# ifndef ULTRIX
		if (c == ctrl ('M'))
			check_tty (slave);
# endif
	}
	done ();
}

void
vt220_input ()
{
	gen_input (&vt220_map, vt220_keys);
}

void
xterm_input ()
{
	gen_input (&xterm_map, xterm_keys);
}

void
sun_input ()
{
	gen_input (&sun_map, sun_keys);
}

void
vt100_input ()
{
	gen_input (&vt100_map, vt100_keys);
}

void
vt100_output ()
{
	u_char              ibuf[BUFSIZ];
	u_char              obuf[4 * BUFSIZ];
	register int        greekf = 0;
	register int        i, j, c, k;
	int                 cc;

	(void) close (0);
	for (;;) {
		cc = read (master, (char *) ibuf, sizeof (ibuf));
		if (cc <= 0)
			break;
		for (i = j = 0; i < cc; i++) {
			c = ibuf[i];

			/*
			 * Do not map white space characters
			 */
			if (isspace (c)) {
				obuf[j++] = c;
				continue;
			}
			if (c & 0200) {
				if (!greekf) {
					for (k = 0; k < GEN_LEN; k++)
						obuf[j++] = genable[k];
					greekf = 1;
				}
				obuf[j++] = vt100_out[c];
			} else {
				if (greekf) {
					for (k = 0; k < GDIS_LEN; k++)
						obuf[j++] = gdisabl[k];
					greekf = 0;
				}
				obuf[j++] = c;
			}
		}
		(void) write (1, (char *) obuf, j);
	}
	done ();
}


void
vt220_output ()
{
	u_char              buf[BUFSIZ];
	register int        cc;

	(void) close (0);
	for (;;) {
		cc = read (master, (char *) buf, sizeof (buf));
		if (cc <= 0)
			break;
		(void) write (1, (char *) buf, cc);
	}
	done ();
}

void
xterm_output ()
{
	u_char              buf[BUFSIZ];

#define	CHAR_LF	'\n'
#define	CHAR_CR	'\r'
	u_char              obuf[2 * BUFSIZ];
	register int        i, j, c;

	int                 cc;

	(void) close (0);

	check_tty (slave);
	while ((cc = read (master, (char *) buf, sizeof (buf))) >= 0) {
		if (map_crlf && tty_map_crlf)
			for (i = j = 0; i < cc; i++) {
				c = buf[i];
				if (c == CHAR_LF)
					obuf[j++] = CHAR_CR;
				obuf[j++] = c;
			}
		if (debug) {
			u_char             *c;

			if (map_crlf && tty_map_crlf)
				for (c = obuf; c < obuf + j; c++)
					debug_print ("out (mapped)", (int) *c);
			else
				for (c = buf; c < buf + cc; c++)
					debug_print ("out (unmapped)", (int) *c);
		}
		if (map_crlf && tty_map_crlf)
			(void) write (1, (char *) obuf, j);
		else
			(void) write (1, (char *) buf, cc);

		check_tty (slave);
	}
	done ();
}

debug_print (msg, c)
	char               *msg;
	int                 c;
{
	extern FILE        *debugfp;

	(void) fprintf (debugfp, "%12s :'", msg);
	putc (c, debugfp);
	(void) fprintf (debugfp, "' '%c'\t%d\t0%o\n", c, c, c);
	(void) fflush (debugfp);
}

/*
 * We will check the tty mode of the slave.
 * It should never be litout (unless it is in the raw mode).
 * In the raw mode we do no cr-lf mapping.
 */

static struct tty_state {

#ifdef  BSD
	struct sgttyb       term;
	struct tchars       tc;
	struct ltchars      lc;
	struct winsize      win;
	int                 lb;
	int                 l;
#else
	struct termio       term;
	int                 junk1;
	int                 junk2;
	int                 junk3;
	int                 junk4;
	int                 junk5;
#endif
};

#ifdef BSD
#	define TRAW(t)		((t)->term.sg_flags & RAW)
#	define TCBREAK(t)	((t)->term.sg_flags & CBREAK)
#	define TNL(t)	    ((t)->term.sg_flags & CRMOD)
#	define TLITOUT(t)	((t)->lb & LLITOUT)
#	define TECHO(t)	((t)->term.sg_flags & ECHO)
#	define TPASS8(t)	((t)->lb & LPASS8)
#else
#	define TRAW(t)		TPASS8(t)
#	define TCBREAK(t)	((t) -> term.c_iflag & ICANON == 0)
#	define TNL(t)	    	((t) -> term.c_iflag & ICANON)
#	define TLITOUT(t)	((t) -> term.c_opost & OPOST == 0)
#	define TECHO(t)	    ((t)->term.c_lflag & ECHO)
#	define TPASS8(t)	(((t) -> term.c_cflag & CS8) && \
				!((t) -> term.c_iflag & ISTRIP))
#endif BSD

check_tty (tty)
	int                 tty;/* the tty we want to inspect */
{
	static struct tty_state old = {0, 0, 0, 0, 0, 0};
	static struct tty_state new;

	/* get the new tty state */
	get_tty (tty, &new);
	/* if the tty has been the same forget it ! */
	if (bcmp (&old, &new, sizeof (old)) == 0)
		return;


	/* if the tty became raw or 'cbreak nl' */
	if (TRAW (&new) || (TCBREAK (&new) && !TNL (&new))) {
		tty_map_crlf = 0;	/* no mapping is necessary */
	} else {
		tty_map_crlf = 1;
	}
	if (!TECHO (&new)) {	/* no need for echo */
		tty_echo = 0;
	} else {
		tty_echo = 1;
	}
#ifdef BSD
# ifdef SUNOS
	if (!TPASS8 (&new)) {	/* make it litout again */
		/* grk cannot work without them ! */
		new.lb |= LPASS8;
		(void) ioctl (tty, TIOCLSET, (char *) &new.lb);
	}
# else SUNOS
	if (!TLITOUT (&new) || !TPASS8 (&new)) {	/* make it litout again */
		/* grk cannot work without them ! */
		new.lb |= LLITOUT;
		new.lb |= LPASS8;
		(void) ioctl (tty, TIOCLSET, (char *) &new.lb);
	}
# endif SUNOS
#endif BSD

	old = new;
	return;
}


/*
 * get the tty characteristics
 */
get_tty (tty, state)
	int                 tty;
	struct tty_state   *state;
{
#ifdef BSD
	/* get terminal parapeters (getty) */
	(void) ioctl (tty, TIOCGETP, (char *) &state -> term);
	/* get special characters */
	(void) ioctl (tty, TIOCGETC, (char *) &state -> tc);
	/* get line disipline */
	(void) ioctl (tty, TIOCGETD, (char *) &state -> l);
	/* get local special chars  */
	(void) ioctl (tty, TIOCGLTC, (char *) &state -> lc);
	/* get local modes */
	(void) ioctl (tty, TIOCLGET, (char *) &state -> lb);
	/* get window characteristics */
	(void) ioctl (tty, TIOCGWINSZ, (char *) &state -> win);
# else
	(void) ioctl (tty, TCGETA, (char *) &state -> term);
# endif BSD

	return;
}

int
To_Greek (c)
        int                 c;
{
        char               *index ();

        return (index ("!@#$%^&*()_-+={}[]~`<>/?;:", c) ? c : togreek (c));
}
