#include <stdio.h>
#include <sys/file.h>
#include <utmp.h>

#define etc_utmp "/etc/utmp"


static              tslot;
long                time (), lseek ();

extern int          utmp_fd;

utmp_open ()
{
	if ((utmp_fd < 0) && (utmp_fd = open (etc_utmp, O_WRONLY)) < 0)
		return -1;
	return 0;
}

utmp_set (ttydev, user, host)
	char               *ttydev;	/* the tty */
	char               *user;	/* user */
	char               *host;	/* host */
{
	struct utmp         ut;
	int                 i;
	char               *strncpy ();
	char		    buf[100];

	if ((tslot = Ttyslot (ttydev)) == 0)
		return -1;

	if ((i = utmp_fd) < 0)
		return -1;


	bzero ((char *) &ut, sizeof (struct utmp));
	(void) strncpy (ut.ut_line, ttydev + strlen ("/dev/"), sizeof (ut.ut_line) - 1);
	(void) sprintf (buf, "%-*.*s", sizeof (ut.ut_name), sizeof (ut.ut_name),
			user);
	(void) memcpy (ut.ut_name, buf, sizeof (ut.ut_name));
	(void) memcpy (ut.ut_host, host, sizeof (ut.ut_host));
	(void) time (&ut.ut_time);
	(void) lseek (i, (long) (tslot * sizeof (struct utmp)), 0);
	(void) write (i, (char *) &ut, sizeof (struct utmp));
	return 0;
}

utmp_reset ()
{
	register int        i;
	struct utmp         utmp;
	extern int          utmp_fd;

	if (tslot > 0 && ((i = utmp_fd) >= 0)) {
		bzero ((char *) &utmp, sizeof (struct utmp));
		(void) lseek (i, (long) (tslot * sizeof (struct utmp)), 0);
		(void) write (i, (char *) &utmp, sizeof (struct utmp));
		tslot = 0;
		(void) close (i);
		utmp_fd = -1;
	}
}

/*
 * Return the number of the slot in the utmp file
 * corresponding to the passed tty.
 * returns 0 on error.
 */


char               *getttys ();
# if defined(SUNOS) && sun
static char         ttys[] = "/etc/ttytab";
# else
static char         ttys[] = "/etc/ttys";
# endif

static 
Ttyslot (tty)
	register char      *tty;
{
	register char      *tp, *p;
	register            s;
	FILE               *tf;
	char               *rindex ();

	tp = tty;

	if ((p = rindex (tp, '/')) == NULL)
		p = tp;
	else
		p++;
	if ((tf = fopen (ttys, "r")) == NULL)
		return (0);
	s = 0;
	while (tp = getttys (tf)) {
		s++;
		if (strcmp (p, tp) == 0) {
			(void) fclose (tf);
			return (s);
		}
	}
	(void) fclose (tf);
	return (0);
}

static char        *
getttys (f)
	FILE               *f;
{
	static char         line[256];
	register char      *lp;

	do {
		if (fgets (line, 256, f) == NULL)
			return NULL;
	} while (*line == '#');	/* ignore comment lines */

	for (lp = line;; lp++) {
		if ((*lp == '\t') || (*lp == ' ') || (*lp == '\n')) {
			*lp = '\0';
			return (line);
		}
	}
}
